import React, { useEffect, useState } from 'react';
import ReactDOM from 'react-dom';
import * as firebase from "firebase";
import "firebase/database";


// For Firebase JS SDK v7.20.0 and later, measurementId is optional
const firebaseConfig = {
  apiKey: "AIzaSyCfJk72rC6N35BtSaI_ivIERqBJazi-y9I",
  authDomain: "fall-test-project.firebaseapp.com",
  databaseURL: "https://fall-test-project.firebaseio.com",
  projectId: "fall-test-project",
  storageBucket: "fall-test-project.appspot.com",
  messagingSenderId: "340451928872",
  appId: "1:340451928872:web:81702c18e1e56e7d9afe1d",
  measurementId: "G-RJL419WD8R"
};

firebase.initializeApp(firebaseConfig);
const db = firebase.database();

function LocationForm(props) {
  return (
    <form onSubmit={props.handleSubmit}>
            <label>Name: </label>
            <input 
             type="text" 
             name="name" 
              />
             <br />

            <label>State</label>
            <select name="state">
                <option value="CA">CA</option>
                <option value="NY">NY</option>
                <option value="TX">TX</option>
            </select><br />

            <input type="submit" value="Save Location" />

        </form>
  );
}

function LocationDisplay(props) {
  /*
  Note on locationList: I ended up taking Ryan's original advice and use
  the map function that is available for all arrays. props.data.map(function) enables
  you to create a new list where you execute the passed in function for every element in 
  data.map.

  Check https://medium.com/@bojangbusiness/javascript-functional-programming-map-filter-and-reduce-846ff9ba492d
  for details
  
  */
  const locationList = props.data.map(
    (location, index) => (<li key={index}>{location.name}: {location.state}</li>));

  return (
    <ul>
      {locationList} 
    </ul>
  );
}

function LocationComponent(props) {
  
  const [data, setData] = useState([]);

  useEffect(() => {
    getExternalData(props.id, setData); //Using useEffect to get external data
  }, [props.id]);

  

  const handleSubmit = (event) =>  {
  	 event.preventDefault();

    /* After the class I simplified this to use a single statement to add the
    current data and add the new data at the end of it 
    */
  	 const newData = [
       ...data, {
       "name": event.target.name.value,
       "state": event.target.state.value
      }];

      setData(newData);
      setExternalData(props.id, newData)
   };

   return (
    <div>
      <LocationForm handleSubmit={handleSubmit} />
      <br />
      <LocationDisplay data={data} />
    </div>
  );
}

  async function getExternalData(id, setData) {
     /* Note: I renamed this getExternalData (which I probably should have done earlier)
     to make this generic. This data now retrieves from Google Firebase. 

     Note I'm also passing in the setData Method
     */
    //const localStorageData = localStorage.getItem(`LocationComponentData${id}`)
    db.ref(`/${id}`).on("value", (snapshot) => { // Anytime the path in json changes, run this function
      const test = snapshot.val();
      
      if (test === null) {
        setData(JSON.parse("[]"));
      } else {
        setData(JSON.parse(test));
      }
    });

    
  }
  
  async function setExternalData(id, curData) {
    /* Note: I renamed this setData (which I probably should have done earlier)
     to make this generic. This data now retrieves from Google Firebase. */
    const thisData = curData;

    /* Note that I use JSON.parse here. localStorage can save only strings. So you need
    the ability to "serialize" an array into text, and to deserialize text back into an
    array. JSON.parse converts a JSON string into an object (in this case an array) and
    JSON.stringify converts an object (in this case an array) into a JSON string */
    await db.ref(`/${id}`).set(JSON.stringify(thisData));
  }


  

function App(props) {
  return (
    <div>
      <LocationComponent id="1" />
    </div>
  );
}

ReactDOM.render(
<App />,
document.getElementById('root')
);


 